//+------------------------------------------------------------------+
//|                                                ATR_indicator.mq4 |
//|                                                          k-matsu |
//|                               http://www.age.jp/~k-matsu/FX/MT4/ |
//+------------------------------------------------------------------+
#property copyright "k-matsu"
#property link      "http://www.age.jp/~k-matsu/FX/MT4/"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red
#property indicator_color2 Blue
//---- input parameters
extern int       AtrPeriod=14;
extern double       AtrRatio=2.0;
//---- buffers
double HigherAtrBuffer[];
double LowerAtrBuffer[];
double TempBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- 1 additional buffer used for counting.
   IndicatorBuffers(3);
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,HigherAtrBuffer);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,LowerAtrBuffer);
   SetIndexBuffer(2,TempBuffer);
//---- name for DataWindow and indicator subwindow label
   short_name="ATR bands("+AtrPeriod+","+AtrRatio+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int    i, counted_bars=IndicatorCounted();
//----
   if(Bars<=AtrPeriod) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=AtrPeriod;i++) { 
        HigherAtrBuffer[Bars-i]=0.0;
        LowerAtrBuffer[Bars-i]=0.0;
      }
//----
   i=Bars-counted_bars-1;
   while(i>=0)
     {
      double high=High[i];
      double low =Low[i];
      if(i==Bars-1) TempBuffer[i]=high-low;
      else
        {
         double prevclose=Close[i+1];
         TempBuffer[i]=MathMax(high,prevclose)-MathMin(low,prevclose);
        }
      i--;
     }
//----
   if(counted_bars>0) counted_bars--;
   int limit=Bars-counted_bars;
   for(i=0; i<limit; i++) {
      double Atrvalue=iMAOnArray(TempBuffer,Bars,AtrPeriod,0,MODE_SMA,i);
      prevclose=Close[i+1];
      HigherAtrBuffer[i]=prevclose+Atrvalue*AtrRatio;
      LowerAtrBuffer[i]=prevclose-Atrvalue*AtrRatio;
   }
   
//----
   return(0);
  }
//+------------------------------------------------------------------+